net.i2p.router.crypto.ratchet

## Class ACKTimer

- java.lang.Object
- - net.i2p.util.SimpleTimer2.TimedEvent
  - - net.i2p.router.crypto.ratchet.ACKTimer

- All Implemented Interfaces:
    Runnable

      class ACKTimer
      extends SimpleTimer2.TimedEvent

  Timer for sending ratchet-layer acknowledgments when application responses are delayed, supporting NS, NSR, ACK requests, and forward next key blocks The vast majority of these will be cancelled before firing, when streaming sends a response. This should only fire if streaming drops completely, and for certain datagram traffic patterns.

- - ### Field Summary

    - ### Fields inherited from class net.i2p.util.SimpleTimer2.TimedEvent

      `_state, DEFAULT_FUZZ`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ACKTimer(RouterContext context, Destination from, Destination to)` ACK timer for ratchet.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `timeReached()` Simple interface for events to be queued up and notified on expiration the time requested has been reached (this call should NOT block, otherwise the whole SimpleTimer gets backed up)

    - ### Methods inherited from class net.i2p.util.SimpleTimer2.TimedEvent

      `cancel, forceReschedule, reschedule, reschedule, run, schedule, setFuzz, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ACKTimer

          public ACKTimer(RouterContext context,
                          Destination from,
                          Destination to)

      ACK timer for ratchet.
      Parameters:
        `context` - router context for timer and logging
        `from` - local destination ACK will come from, non-null
        `to` - remote destination ACK will go to, non-null

  - ### Method Detail

    - #### timeReached

          public void timeReached()

      Description copied from class: `SimpleTimer2.TimedEvent`
      Simple interface for events to be queued up and notified on expiration the time requested has been reached (this call should NOT block, otherwise the whole SimpleTimer gets backed up)
      Specified by:
        `timeReached` in class `SimpleTimer2.TimedEvent`